# coding: utf-8

"""
    Robust Intelligence Firewall REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` header.

    The version of the OpenAPI document: 1.0
    Contact: dev@robustintelligence.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ri.fwclient.models.generativefirewall_firewall_instance_deployment_config import GenerativefirewallFirewallInstanceDeploymentConfig
from ri.fwclient.models.generativefirewall_firewall_rule_config import GenerativefirewallFirewallRuleConfig
from ri.fwclient.models.rime_uuid import RimeUUID
from typing import Optional, Set
from typing_extensions import Self

class GenerativefirewallCreateFirewallInstanceRequest(BaseModel):
    """
    GenerativefirewallCreateFirewallInstanceRequest
    """ # noqa: E501
    config: Optional[GenerativefirewallFirewallRuleConfig] = None
    description: Optional[StrictStr] = Field(default=None, description="Optional human-readable description of the firewall instance.")
    spec: Optional[GenerativefirewallFirewallInstanceDeploymentConfig] = None
    firewall_instance_id: Optional[RimeUUID] = Field(default=None, alias="firewallInstanceId")
    __properties: ClassVar[List[str]] = ["config", "description", "spec", "firewallInstanceId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GenerativefirewallCreateFirewallInstanceRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of config
        if self.config:
            _dict['config'] = self.config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of spec
        if self.spec:
            _dict['spec'] = self.spec.to_dict()
        # override the default output from pydantic by calling `to_dict()` of firewall_instance_id
        if self.firewall_instance_id:
            _dict['firewallInstanceId'] = self.firewall_instance_id.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GenerativefirewallCreateFirewallInstanceRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "config": GenerativefirewallFirewallRuleConfig.from_dict(obj["config"]) if obj.get("config") is not None else None,
            "description": obj.get("description"),
            "spec": GenerativefirewallFirewallInstanceDeploymentConfig.from_dict(obj["spec"]) if obj.get("spec") is not None else None,
            "firewallInstanceId": RimeUUID.from_dict(obj["firewallInstanceId"]) if obj.get("firewallInstanceId") is not None else None
        })
        return _obj


